unit CompStrU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    btnComponentToString: TButton;
    memGuineaPig: TMemo;
    memComponentString: TMemo;
    btnStringToComponent: TButton;
    procedure btnComponentToStringClick(Sender: TObject);
    procedure btnStringToComponentClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function ComponentToString(AComp: TComponent): String;
var
  InputStream: TMemoryStream;
  OutputStream: TStringStream;
begin
  InputStream := TMemoryStream.Create;
  OutputStream := TStringStream.Create('');
  try
    { Put component on stream }
    InputStream.WriteComponent(AComp);
    { Reset pointer to beginning of input stream }
    InputStream.Seek(0, soFromBeginning);
    { Turn component into string }
    ObjectBinaryToText(InputStream, OutputStream);
    { Display string in the other memo }
    Result := OutputStream.DataString
  finally
    InputStream.Free;
    OutputStream.Free;
  end;
end;

function StringToComponent(const AString: String; AComp: TComponent): TComponent;
var
  InputStream: TStringStream;
  OutputStream: TMemoryStream;
begin
  InputStream := TStringStream.Create(AString);
  OutputStream := TMemoryStream.Create;
  try
    { Turn string into component }
    ObjectTextToBinary(InputStream, OutputStream);
    { Go back to start of output stream }
    OutputStream.Seek(0, soFromBeginning);
    { Read component from stream, creating one if one is not passed in }
    Result := OutputStream.ReadComponent(AComp)
  finally
    InputStream.Free;
    OutputStream.Free
  end
end;

procedure TForm1.btnComponentToStringClick(Sender: TObject);
begin
  memComponentString.Text := ComponentToString(memGuineaPig)
end;

procedure TForm1.btnStringToComponentClick(Sender: TObject);
begin
  StringToComponent(memComponentString.Text, memGuineaPig)
end;

end.
